var s = require('sodium-native')
var zero = require('dev-zero-stream')
var crypto = require('crypto')

if (process.argv[2] === 'sodium') {
  console.log('Benching sodium-native streaming hash')

  var then = Date.now()
  var stream = s.crypto_generichash_stream()

  zero(1024 * 1024 * 1024)
    .on('data', function (data) {
      stream.update(data)
    })
    .on('end', function () {
      var output = new Buffer(s.crypto_generichash_BYTES)
      stream.final(output)
      console.log(Date.now() - then, output)
    })
} else {
  console.log('Benching node core streaming hash')

  var then = Date.now()
  var stream = crypto.createHash('sha256')

  zero(1024 * 1024 * 1024)
    .on('data', function (data) {
      stream.update(data)
    })
    .on('end', function () {
      var output = stream.digest()
      console.log(Date.now() - then, output)
    })
}


